import { IExcelParserData } from "../interfaces";
export declare class ExcelParser {
    /**
   * Parse an excel table into JS objects
   * uploadFolderPath refers to the absolute path of the folder, from the root, that will store the excel file temporarily.
   * This need is a result of the middleware logic stored in the file Upload.middleware.ts of the core api
   * @param data - refers to the data necessary to parse.
   * @returns returns js objects
   */
    parse<T = any>(data: IExcelParserData): Promise<T[][]>;
    private deleteFile;
}
