"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeDeep = exports.timeout = exports.randomSixDigitNumber = exports.pipe = void 0;
function pipe(...fns) {
    return (x) => fns.reduce((v, f) => f(v), x);
}
exports.pipe = pipe;
function randomSixDigitNumber() {
    return Math.floor(100000 + Math.random() * 900000);
}
exports.randomSixDigitNumber = randomSixDigitNumber;
function timeout(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
}
exports.timeout = timeout;
function isObject(obj) {
    return !!obj && obj.constructor === Object;
}
function mergeDeep(target, source) {
    if (!isObject(target) || !isObject(source)) {
        return source;
    }
    Object.keys(source).forEach(key => {
        const targetValue = target[key];
        const sourceValue = source[key];
        if (Array.isArray(targetValue) && Array.isArray(sourceValue)) {
            target[key] = targetValue.concat(sourceValue);
        }
        else if (isObject(targetValue) && isObject(sourceValue)) {
            target[key] = mergeDeep(Object.assign({}, targetValue), sourceValue);
        }
        else {
            target[key] = sourceValue;
        }
    });
    return target;
}
exports.mergeDeep = mergeDeep;
