"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCacheClient = exports.CacheClient = void 0;
const redis_1 = require("redis");
const factory = (options) => {
    return redis_1.createClient(options);
};
class CacheClient {
    static getInstance() {
        if (!CacheClient.instance) {
            throw new Error('Cache client has not been initialized yet');
        }
        return CacheClient.instance;
    }
    static async initialize(options) {
        if (!CacheClient.instance) {
            const instance = new CacheClient();
            instance.client = factory(options);
            await instance.client.connect();
            CacheClient.instance = instance;
        }
    }
    get redisClient() {
        return this.client;
    }
}
exports.CacheClient = CacheClient;
function getCacheClient() {
    const cacheClient = CacheClient.getInstance();
    return cacheClient.redisClient;
}
exports.getCacheClient = getCacheClient;
